#ifndef __BUFFER_H
#define __BUFFER_H

#include <stddef.h>

struct buffer
{
	size_t capacity;
	size_t len;
	char *buf;
};

struct buffer buffer_create ();
void buffer_append (const char *s, struct buffer *b);
void buffer_printf (struct buffer *b, const char *fmt, ...);
char *buffer_get (struct buffer *b);
_Bool buffer_read (const char *path, struct buffer *b);
_Bool buffer_eq (const char *s, struct buffer *b);
char *buffer_slice (unsigned int start, unsigned int end, struct buffer *b);
void buffer_free (struct buffer *b);

size_t buffer_length (struct buffer *b);

#endif
